#include <Windows.h>

extern "C"
{
    struct plugin
    {
        const unsigned api_abi;
        const char *version;
        const char *author;
        const char *url;
        const char *email;
        const char *date;
        const char *note[10];
    };

    struct syntaxDesc
    {
        const char *syntaxArgs[11];
        const char *description;
    };

    struct ident_syntax
    {
        const char *name;
        const struct syntaxDesc contents[10];
    };

    struct identifier
    {
        const char *name;
        unsigned min;
        unsigned max;
        bool needsEven;
        bool needsOdd;
        const char *props[35];
    };

    struct identifier2
    {
        const char *name;
    };

    static const struct plugin info =
    {
        1,
        "1.0.1",
        "Reko Tiira [ ramirez ]",
        "http://reko.tiira.net/mmysql/",
        "reko@tiira.net",
        "18th August 2009",
        {
            "ramirez @ irc.undernet.org [ #mircscripting ], ramirez @ irc.swiftirc.net [ #msl ]",
            NULL
        }
    };

    static const struct identifier idents[] =
    { 
        /* { "name", min, max, needsEven, needsOdd, { "props", NULL } } */
        { "$mysql_affected_rows",       1,  1,   false,  false,  { NULL } },
        { "$mysql_autocommit",          1,  2,   false,  false,  { NULL } },
        { "$mysql_begin",               1,  1,   false,  false,  { NULL } },
        { "$mysql_bind_column",         3,  3,   false,  false,  { "name", NULL } },
        { "$mysql_bind_field",          3,  3,   false,  false,  { "name", NULL } },
        { "$mysql_bind_null",           2,  2,   false,  false,  { NULL } },
        { "$mysql_bind_param",          3,  3,   false,  false,  { NULL } },
        { "$mysql_bind_value",          3,  3,   false,  false,  { NULL } },
        { "$mysql_clear_bindings",      1,  1,   false,  false,  { NULL } },
        { "$mysql_client_encoding",     1,  1,   false,  false,  { NULL } },
        { "$mysql_close",               1,  1,   false,  false,  { NULL } },
        { "$mysql_commit",              1,  1,   false,  false,  { NULL } },
        { "$mysql_connect",             2,  4,   false,  false,  { NULL } },
        { "$mysql_data_seek",           2,  2,   false,  false,  { NULL } },
        { "$mysql_escape_string",       1,  1,   false,  false,  { NULL } },
        { "$mysql_exec",                1, -1,   false,  false,  { "file", NULL } },
        { "$mysql_exec_file",           2, -1,   false,  false,  { NULL } },
        { "$mysql_fetch_all",           2,  3,   false,  false,  { NULL } },
        { "$mysql_fetch_assoc",         2,  2,   false,  false,  { NULL } },
        { "$mysql_fetch_bound",         1,  2,   false,  false,  { NULL } },
        { "$mysql_fetch_field",         2,  3,   false,  false,  { "name", NULL } },
        { "$mysql_fetch_field_info",    2,  3,   false,  false,  { NULL } },
        { "$mysql_fetch_num",           2,  2,   false,  false,  { NULL } },
        { "$mysql_fetch_row",           2,  3,   false,  false,  { NULL } },
        { "$mysql_fetch_single",        1,  2,   false,  false,  { NULL } },
        { "$mysql_field_flags",         2,  2,   false,  false,  { NULL } },
        { "$mysql_fetch_field_info",    2,  2,   false,  false,  { NULL } },
        { "$mysql_field_len",           2,  2,   false,  false,  { NULL } },
        { "$mysql_field_name",          2,  2,   false,  false,  { NULL } },
        { "$mysql_field_table",         2,  2,   false,  false,  { NULL } },
        { "$mysql_field_type",          2,  2,   false,  false,  { NULL } },
        { "$mysql_free",                1,  1,   false,  false,  { NULL } },
        { "$mysql_free_result",         1,  1,   false,  false,  { NULL } },
        { "$mysql_get_host_info",       1,  1,   false,  false,  { NULL } },
        { "$mysql_get_proto_info",      1,  1,   false,  false,  { NULL } },
        { "$mysql_get_server_info",     1,  1,   false,  false,  { NULL } },
        { "$mysql_insert_id",           1,  1,   false,  false,  { NULL } },
        { "$mysql_is_valid_connection", 1,  1,   false,  false,  { NULL } },
        { "$mysql_is_valid_result",     1,  1,   false,  false,  { NULL } },
        { "$mysql_is_valid_statement",  1,  1,   false,  false,  { NULL } },
        { "$mysql_num_fields",          1,  1,   false,  false,  { NULL } },
        { "$mysql_num_rows",            1,  1,   false,  false,  { NULL } },
        { "$mysql_ping",                1,  1,   false,  false,  { NULL } },
        { "$mysql_prepare",             2,  2,   false,  false,  { "file", NULL } },
        { "$mysql_qt",                  1,  1,   false,  false,  { NULL } },
        { "$mysql_query",               1, -1,   false,  false,  { "file", NULL } },
        { "$mysql_real_escape_string",  2,  2,   false,  false,  { NULL } },
        { "$mysql_result",              2,  3,   false,  false,  { "name", NULL } },
        { "$mysql_rollback",            1,  1,   false,  false,  { NULL } },
        { "$mysql_safe_decode",         1,  1,   false,  false,  { NULL } },
        { "$mysql_safe_encode",         1,  2,   false,  false,  { NULL } },
        { "$mysql_select_db",           2,  2,   false,  false,  { NULL } },
        { "$mysql_set_charset",         2,  2,   false,  false,  { NULL } },
        { "$mysql_unbuffered_query",    1, -1,   false,  false,  { "file", NULL } },
        { NULL, 0, 0, false, false, { NULL } }
    };

    static const struct identifier2 idents2[] =
    {
        { "$mysql_get_client_info" },
        { "$mysql_version" },

        { "$MYSQL_OK" },

        { "$MYSQL_BOTH" },
        { "$MYSQL_NUM" },
        { "$MYSQL_ASSOC" },

        { "$MYSQL_ALL" },
        { "$MYSQL_BOUND" },

        { "$MYSQL_ERROR_OK" },
        { "$MYSQL_ERROR_INVALIDARG" },
        { "$MYSQL_ERROR_BIND" },
        { "$MYSQL_ERROR_NOMOREROWS" },
        { "$MYSQL_ERROR_FETCH" },
        { "$MYSQL_ERROR_NOMOREFIELDS" },
        { NULL }
    };

    static struct ident_syntax syntax[] =
    {
        {"$mysql_affected_rows",
            {
                { { "connection", 0 }, "Returns a number of affected rows of the last INSERT, UPDATE or DELETE query." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_autocommit",
            {
                { { "connection", 0 }, "Returns autocommit mode current state." },
                { { "connection", "~~0", 0 }, "Turns off autocommit mode." },
                { { "connection", "~~1", 0 }, "Turns on autocommit mode." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_begin",
            {
                { { "connection", 0 }, "Begins a transaction." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_bind_column",
            {
                { { "result", "column", "var", 0 }, "Binds a column to a variable." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_bind_field",
            {
                { { "result", "column", "var", 0 }, "Binds a column to a variable." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_bind_null",
            {
                { { "statement", "param", 0 }, "Binds null as a parameter for prepared statement." },
                { { 0 }, 0 }
            }
        },
        {"$mysql_bind_param",
            {
                { { "statement", "param", "var", 0 }, "Binds a variable as a parameter for prepared statement." },
                { { 0 }, 0 }
            }
        },
        { 0, { { { 0 }, 0 } } }
    };

    __declspec(dllexport) const struct identifier *getIdentsList()
    {
        return idents;
    }

    __declspec(dllexport) const struct identifier2 *getIdents2List()
    {
        return idents2;
    }
    __declspec(dllexport) const struct ident_syntax *getIdentsSyntaxList()
    {
        return syntax;
    }

    __declspec(dllexport) const struct plugin *getPluginInfo()
    {
        return &info;
    }

    BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved )
    {
        switch(fdwReason)
        {
            case DLL_THREAD_ATTACH:
            case DLL_THREAD_DETACH:
                break;
            case DLL_PROCESS_ATTACH:
            {
                /* init */
                break;
            }
            case DLL_PROCESS_DETACH:
            {
                /* cleanup */
                break;
            }
        }
        return TRUE;
    }
}